package ru.dbotthepony.mc.otm.registry

import net.minecraft.network.chat.Component
import net.minecraft.network.chat.TranslatableComponent
import net.minecraft.world.damagesource.DamageSource
import net.minecraft.world.entity.Entity
import net.minecraft.world.entity.LivingEntity
import net.minecraft.world.item.ItemStack

class EMPDamageSource(private val entity: Entity? = null) : DamageSource(MRegistry.DAMAGE_EMP_NAME) {
	init {
		bypassArmor()
		bypassMagic()
	}

	override fun scalesWithDifficulty(): Boolean {
		return false
	}

	override fun getLocalizedDeathMessage(victim: LivingEntity): Component {
		val itemStack = (entity as LivingEntity?)?.mainHandItem ?: ItemStack.EMPTY

		if (!itemStack.isEmpty && itemStack.hasCustomHoverName()) {
			return TranslatableComponent("death.attack.otm_emp.player.item", victim.displayName, entity!!.displayName, itemStack.displayName)
		}

		if (entity != null) {
			return TranslatableComponent("death.attack.otm_emp.player", victim.displayName, entity.displayName)
		}

		return TranslatableComponent("death.attack.otm_emp", victim.displayName)
	}

	override fun getEntity(): Entity? {
		return entity
	}
}
